VERSION 5.00
Begin VB.Form frmCreateHTML 
   Caption         =   "Create HTML Calendar files"
   ClientHeight    =   4260
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7275
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4260
   ScaleWidth      =   7275
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   495
      Left            =   2520
      TabIndex        =   16
      Top             =   3600
      Width           =   1215
   End
   Begin VB.TextBox txtPrefix 
      Height          =   285
      Left            =   2040
      TabIndex        =   13
      Top             =   3120
      Width           =   1575
   End
   Begin VB.TextBox txtCalTitle 
      Height          =   495
      Left            =   1560
      TabIndex        =   12
      Top             =   480
      Width           =   5415
   End
   Begin VB.DriveListBox drvOut 
      Height          =   315
      Left            =   2040
      TabIndex        =   8
      Top             =   2640
      Width           =   1575
   End
   Begin VB.DirListBox dirOut 
      Height          =   1890
      Left            =   3840
      TabIndex        =   7
      Top             =   2040
      Width           =   2775
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Create Calendar"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   3600
      Width           =   2175
   End
   Begin VB.ComboBox cmbEndYear 
      Height          =   315
      Left            =   5760
      TabIndex        =   4
      Text            =   "Combo4"
      Top             =   1080
      Width           =   1215
   End
   Begin VB.ComboBox cmbEndMonth 
      Height          =   315
      Left            =   4320
      TabIndex        =   3
      Text            =   "Combo3"
      Top             =   1080
      Width           =   1215
   End
   Begin VB.ComboBox cmbBegYear 
      Height          =   315
      Left            =   2160
      TabIndex        =   2
      Text            =   "Combo2"
      Top             =   1080
      Width           =   1215
   End
   Begin VB.ComboBox cmbBegMonth 
      Height          =   315
      Left            =   720
      TabIndex        =   1
      Text            =   "Combo1"
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label lblOutDir 
      Height          =   375
      Left            =   360
      TabIndex        =   15
      Top             =   1560
      Width           =   6255
   End
   Begin VB.Label Label5 
      Caption         =   "File Prefix"
      Height          =   255
      Left            =   1080
      TabIndex        =   14
      Top             =   3120
      Width           =   855
   End
   Begin VB.Label Label4 
      Caption         =   "Calendar Title"
      Height          =   375
      Left            =   120
      TabIndex        =   11
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "to"
      Height          =   255
      Left            =   3480
      TabIndex        =   10
      Top             =   1080
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "From"
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   1080
      Width           =   495
   End
   Begin VB.Label Label3 
      Caption         =   "Select folder for calendar files"
      Height          =   495
      Left            =   480
      TabIndex        =   6
      Top             =   2040
      Width           =   3015
   End
   Begin VB.Label lblHelp 
      Alignment       =   2  'Center
      Caption         =   "Select Date Range for Calendar, then click 'Create'"
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   7335
   End
End
Attribute VB_Name = "frmCreateHTML"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim FirstTime As Boolean


Private Sub cmdCreate_Click()
    create_calendar
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub

Private Sub dirOut_Change()
    OutputDir = dirOut.Path
    lblOutDir.Caption = OutputDir
End Sub

Private Sub drvOut_Change()
    dirOut.Path = drvOut.Drive
End Sub

Private Sub Form_Activate()
    If FirstTime Then
        init_form
        FirstTime = False
    End If
End Sub

Private Sub Form_Load()
    FirstTime = True
    Me.Width = mdiStakeCal.Width - 500
    Me.Height = mdiStakeCal.Height - 1000
End Sub
Sub init_form()
    load_month cmbBegMonth
    load_month cmbEndMonth
    load_year cmbBegYear
    load_year cmbEndYear
    load_events
    dirOut.Path = App.Path
    OutputDir = dirOut.Path
    lblOutDir.Caption = OutputDir
    txtCalTitle.Text = CalTitle
End Sub
Sub load_month(cmb As ComboBox)
    cmb.Clear
    cmb.AddItem "January"
    cmb.AddItem "February"
    cmb.AddItem "March"
    cmb.AddItem "April"
    cmb.AddItem "May"
    cmb.AddItem "June"
    cmb.AddItem "July"
    cmb.AddItem "August"
    cmb.AddItem "September"
    cmb.AddItem "October"
    cmb.AddItem "November"
    cmb.AddItem "December"
    
    Dim dt As Date
    dt = DateTime.Now
    Dim mon As Integer
    mon = Month(dt)
    cmb.ListIndex = mon - 1
End Sub
Sub load_year(cmb As ComboBox)
    Dim dt As Date
    Dim yr As Integer
    
    dt = DateTime.Now   ' get current date
    yr = Year(dt)
    
    ' date range is from previous year to current year
    cmb.Clear   ' clear list
    cmb.AddItem yr - 1 & ""
    cmb.AddItem yr & ""
    cmb.AddItem yr + 1 & ""
    cmb.ItemData(0) = yr - 1
    cmb.ItemData(1) = yr
    cmb.ItemData(2) = yr + 1
    cmb.ListIndex = 1   ' select current year
End Sub
Sub load_events()
    ' if some events have already been selected, do nothing
    ' if no event types have been selected, select all
    ' otherwise select all events for the given event types
    If NumEvents = 0 And NumEventTypes = 0 And NumUnitNames = 0 Then
        load_all
    Else
        load_selected
    End If
End Sub
Sub load_all()
    NumEvents = 0   ' clear any previous list
    
    Dim sql As String
    
    sql = "select * from " & TableName
    add_query (sql)
    
End Sub
Sub load_selected()
    Dim s As String ' work string
    Dim s2 As String
    Dim s1 As String
    Dim s0 As String
    Dim sql As String
    
    ' build list of event types that were selected
    Dim i As Integer
    
    s = BuildEventWhere()
    s2 = BuildUnitWhere()
    If Len(s) > 0 And Len(s2) > 0 Then s1 = " and "
    If Len(s) > 0 Or Len(s2) > 0 Then s0 = " where "
    
    sql = "select * from " & TableName & s0 & s & s1 & s2 & s3

    add_query (sql)
End Sub
Sub add_query(sql As String)
    Dim rsCal As ADODB.Recordset
    
    Set rsCal = New ADODB.Recordset
    rsCal.Open sql, dbConnection, , , adCmdText
    
    NumEvents = 0
    Do While Not rsCal.EOF
        Events(NumEvents).EID = rsCal("ID").Value
        Events(NumEvents).EDate = rsCal("EventDate").Value
        If Not IsNull(rsCal("begtime").Value) Then
            Events(NumEvents).EBegTime = rsCal("BegTime").Value
            Events(NumEvents).ETime = rsCal("BegTime").Value
        End If
        If Not IsNull(rsCal("EndTime").Value) Then
            Events(NumEvents).EEndTime = rsCal("EndTime").Value
        End If
        If Not IsNull(rsCal("EventDesc").Value) Then
            Events(NumEvents).EDesc = rsCal("EventDesc").Value
        End If
        If Not IsNull(rsCal("Stake").Value) Then
            Events(NumEvents).EStake = rsCal("Stake").Value
        End If
        If Not IsNull(rsCal("EventType").Value) Then
            Events(NumEvents).EType = rsCal("EventType").Value
        End If
        If Not IsNull(rsCal("Contact").Value) Then
            Events(NumEvents).EContact = rsCal("Contact").Value
        End If
        If Not IsNull(rsCal("Comments").Value) Then
            Events(NumEvents).EComments = rsCal("Comments").Value
        End If
        NumEvents = NumEvents + 1
        rsCal.MoveNext
    Loop
    rsCal.Close
    Set rsCal = Nothing
End Sub
Sub create_calendar()
    Dim dt1 As Date
    Dim dt2 As Date
    Dim beg_yr As Integer, end_yr As Integer
    Dim beg_mon As Integer, end_mon As Integer
    
    beg_mon = cmbBegMonth.ListIndex + 1
    end_mon = cmbEndMonth.ListIndex + 1
    beg_yr = cmbBegYear.ItemData(cmbBegYear.ListIndex)
    end_yr = cmbEndYear.ItemData(cmbEndYear.ListIndex)
    dt1 = beg_mon & "/1/" & beg_yr
    dt2 = end_mon & "/" & max_days_in_month(end_mon, end_yr) & "/" & end_yr
    
    CalTitle = Trim(txtCalTitle.Text)
    CalFilePrefix = Trim(txtPrefix.Text)
    
    create_html dt1, dt2
    MsgBox "Calendar Created", vbOKOnly, "Calendar Created"
End Sub

