VERSION 5.00
Begin VB.Form frmRecur 
   Caption         =   "Schedule Recurring Events"
   ClientHeight    =   4380
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   4380
   ScaleWidth      =   4680
   Begin VB.CommandButton cmdDone 
      Caption         =   "Done"
      Height          =   495
      Left            =   3120
      TabIndex        =   18
      Top             =   3720
      Width           =   1215
   End
   Begin VB.TextBox txtTime 
      Height          =   375
      Left            =   3240
      TabIndex        =   15
      Top             =   360
      Width           =   1215
   End
   Begin VB.TextBox txtDesc 
      Height          =   375
      Left            =   240
      TabIndex        =   13
      Top             =   2280
      Width           =   3255
   End
   Begin VB.CommandButton cmdShow 
      Caption         =   "Show"
      Height          =   495
      Left            =   240
      TabIndex        =   12
      Top             =   3720
      Width           =   1215
   End
   Begin VB.CommandButton cmdInsert 
      Caption         =   "Insert"
      Height          =   495
      Left            =   1680
      TabIndex        =   11
      Top             =   3720
      Width           =   1215
   End
   Begin VB.ListBox lstEvent 
      Height          =   840
      Left            =   240
      TabIndex        =   10
      Top             =   2760
      Width           =   4095
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "Pick Date"
      Height          =   495
      Left            =   1800
      TabIndex        =   9
      Top             =   840
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Pick Date"
      Height          =   495
      Left            =   240
      TabIndex        =   8
      Top             =   840
      Width           =   1215
   End
   Begin VB.ComboBox cmbInterval 
      Height          =   315
      Left            =   1800
      TabIndex        =   5
      Text            =   "Interval"
      Top             =   1680
      Width           =   1695
   End
   Begin VB.TextBox txtInterval 
      Height          =   375
      Left            =   240
      TabIndex        =   4
      Top             =   1680
      Width           =   1215
   End
   Begin VB.TextBox txtStop 
      Height          =   375
      Left            =   1800
      TabIndex        =   1
      Top             =   360
      Width           =   1215
   End
   Begin VB.TextBox txtStart 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
   Begin VB.Label Label7 
      Alignment       =   2  'Center
      Caption         =   "Enter event information and click 'Show' to display events, or 'Insert' to add them to calendar"
      Height          =   1815
      Left            =   3600
      TabIndex        =   17
      Top             =   840
      Width           =   855
   End
   Begin VB.Label Label6 
      Alignment       =   2  'Center
      Caption         =   "Time (optional)"
      Height          =   255
      Left            =   3240
      TabIndex        =   16
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label Label5 
      Alignment       =   2  'Center
      Caption         =   "Event Description"
      Height          =   375
      Left            =   240
      TabIndex        =   14
      Top             =   2040
      Width           =   3975
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "Interval Size"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   1440
      Width           =   1215
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "Interval Type"
      Height          =   255
      Left            =   1920
      TabIndex        =   6
      Top             =   1440
      Width           =   1455
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "Stop Date"
      Height          =   375
      Left            =   1800
      TabIndex        =   3
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Start Date"
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmRecur"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim FirstTime As Boolean

Sub set_date_start()
    If frmCalendar.ok Then
        txtStart.Text = CalDate
    End If
End Sub
Sub set_date_end()
    If frmCalendar.ok Then
        txtStop.Text = CalDate
    End If
End Sub

Private Sub cmdDone_Click()
    Unload Me
End Sub

Private Sub cmdEnd_Click()
    CalForm = "recstop"
    CalDate = ""
    frmCalendar.Show
End Sub

Private Sub cmdInsert_Click()
    insert_events
End Sub

Private Sub cmdShow_Click()
    show_dates
End Sub

Private Sub cmdStart_Click()
    CalForm = "recstart"
    CalDate = ""
    frmCalendar.Show
End Sub

Private Sub Form_Activate()
    If FirstTime Then
        init_form
    End If
End Sub

Private Sub Form_Load()
    FirstTime = True
End Sub
Sub init_form()
    cmbInterval.AddItem "Select repeat interval"
    cmbInterval.AddItem "Days"
    cmbInterval.AddItem "Weeks"
    cmbInterval.AddItem "Months"
End Sub
Sub show_dates()
    ' start, end, and work dates
    Dim DStart As Date
    Dim DStop As Date
    Dim DWork As Date
    ' interval code 1=day, 7=week, 30=month
    Dim Interval As Integer
    Dim IType As String
    ' working fields
    Dim m As Integer
    Dim d As Integer
    Dim y As Integer
    ' working string
    Dim t As String ' event time
    Dim desc As String ' event description
    Dim s As String ' used for additem
    
    t = Trim(txtTime.Text) ' can be empty
    desc = Trim(txtDesc.Text) ' required field
    If desc = "" Then
        Call MsgBox("Enter an event description", vbOKOnly, "Invalid Request")
        Exit Sub
    End If
    Interval = cmbInterval.ListIndex
    If Interval = 0 Then
        Call MsgBox("Please select an interval", vbOKOnly, "Invalid Request")
        Exit Sub
    ElseIf Interval = 1 Then
        IType = "d" ' already set up correctly
    ElseIf Interval = 2 Then
        IType = "ww" ' week
    ElseIf Interval = 3 Then
        IType = "m" ' month
    Else
        Call MsgBox("Unknown Interval selected", vbOKOnly, "Invalid Interval Selected")
        Exit Sub
    End If
    If txtInterval.Text = "" Then
        Interval = 1
    Else
        Interval = txtInterval.Text
        If Interval < 0 Then
            Call MsgBox("Invalid Interval Size", vbOKOnly, "Invalid Interval Specified")
            Exit Sub
        ElseIf Interval = 0 Then
            Interval = 1
        End If
    End If
    
    ' get start and ending dates
    DStart = txtStart.Text
    DStop = txtStop.Text
    
    lstEvent.Clear
    DWork = DStart  ' first event
    Do While DWork <= DStop
        m = Month(DWork)
        d = day(DWork)
        y = Year(DWork)
        s = m & "/" & d & "/" & y & vbTab & t & vbTab & desc
        lstEvent.AddItem s
        ' increment to next date
        DWork = DateAdd(IType, Interval, DWork)
    Loop
End Sub
Sub insert_events()
    Dim s As String
    Dim i As Integer
    Dim loc As Integer
    Dim sql As String
    Dim cols As String
    Dim vals As String
    Dim d As String ' date field
    
    Dim rsCal As ADODB.Recordset
    Set rsCal = New ADODB.Recordset
    rsCal.ActiveConnection = dbConnection
    
    If txtTime.Text = "" Then
        cols = "(EventDate,EventDesc)"
        vals = "','" & txtDesc.Text & "')"
    Else ' time given
        cols = "(EventDate,BegTime,EventDesc)"
        vals = "','" & txtTime.Text & "','" & txtDesc.Text & "')"
    End If
    For i = 0 To lstEvent.ListCount - 1
        s = lstEvent.List(i)
        loc = InStr(s, vbTab)
        d = Left(s, loc - 1)
        sql = "insert into " & TableName & cols & " values ('" & d & vals
        ' Call MsgBox(sql)
        rsCal.Open sql, , , , adCmdText
    Next
    Call MsgBox(lstEvent.ListCount & " events added", vbOKOnly, "Events inserted")
End Sub
